﻿using System;
using System.Windows;
using System.ComponentModel;
using System.Windows.Data;

namespace WpfApplication11 {
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window {
		private bool firstLoaded;
		private DataSourceProvider dp;

		public Window1() {
			InitializeComponent();
			dp = (DataSourceProvider)FindResource( "ObjProvider" );

			Loaded += ( sender, e ) => {
				ObjectDataProvider objDp;

				if ( !firstLoaded ) {
					firstLoaded = true;
					using ( dp.DeferRefresh() ) {
						objDp = (ObjectDataProvider)dp;
						objDp.MethodParameters.Add( "dummy" );
					}
				}
			};
		}

		private void ObjectDataProvider_DataChanged( object sender, EventArgs e ) {
		}
	}

	[Serializable]
	public class MyListSubclass<T, C> : BindingList<C> {

	}

	[Serializable]
	public class MyList : MyListSubclass<MyList, MyObject> {
		public static MyList GetList( string dummy ) {
			return new MyList();
		}

		protected override object AddNewCore() {
			MyObject result;

			result = MyObject.New();
			OnAddingNew( new AddingNewEventArgs( result ) );
			Add( result );

			return result;
		}

		private MyList() {
			AllowEdit = true;
			AllowNew = true;
			AllowRemove = true;
		}
	}

	[Serializable]
	public class MyObject {
		public string MyString { get; set; }
		public bool MyBool { get; set; }

		internal static MyObject New() {
			return new MyObject();
		}

		private MyObject() { }
	}
}
